module Trap

  def otrap( client, trap, point )

    if trap.trap_teleporter?
      trap_teleporter( client, trap, point )
    elsif trap.trap_arrow?
      trap_arrow( client, trap, point )
    elsif trap.trap_dart?
      trap_dart( client, trap, point )
    elsif trap.trap_door?
      trap_door( client, trap, point )
    end
      
  end
  
  def trap_teleporter( client, trap, point )

    player = client.player
    
    return if trap_escape?( client, trap, :escape_teleporter? )

    # ȯ
    trap_found( client, trap, point, player.mesg[ 905 ] )
    
    # ƥݡȤޤ
    teleport( client, error = false )

  end

  def trap_arrow( client, trap, point )

    player = client.player

    # Ǥ뤫ɤ?
    return if trap_escape?( client, trap, :escape_arrow? )
    
    trap_found( client, trap, point, player.mesg[ 906 ] )
    death_arrow( client, rnd( 10 ) + @level )

  end

  def trap_dart( client, trap, point )

    player = client.player

    return if trap_escape?( client, trap, :escape_dart? )

    trap_found( client, trap, point, player.mesg[ 907 ] )

    player.strength_down
    death_dart( client, rnd( 5 ) )
    
  end

  def trap_escape?( client, trap, method )
    return ( trap.hidden? && client.player.send( method ) )
  end
  
  def trap_found( client, trap, point, mesg )

    message( client, mesg )
    trap.found
    update_point( client, point )
        
  end

  def fall_damage( client )
    death_fell_throught_door( client, rnd( 5 + @level ) )
  end

  def do_trap_door( client, trap, point )

    player = client.player
    
    if @cavelevel.bottom? # ʤޤ¨ࡣ

      trap_found( client, trap, point, player.mesg[ 908 ] )
      death_fell_through_bottomless( client )

    else
      
      trap_found( client, trap, point, player.mesg[ 909 ] )
      leave( client )
      @server.push( [ :fall_join, client, @level + 1, point ] )
      
    end

  end
  
  def trap_door( client, trap, point )

    # 
    return if trap_escape?( client, trap, :escape_door? )

    do_trap_door( client, trap, point )
  
  end
  
end
