module Spell

  class SPHERE
    
    attr_reader :dir, :life
    
    def initialize( player, dir, life )
      @player = player # Ӿԡ
      @dir    = dir    # ѡ
      @life   = life   # sphereμ̿
    end
  
    def weaken # 1󤴤Ȥ˰Ϥޤޤ
      @life -= 1
    end
    
    DIR = "hjklyubn"
    
    def change_dir
      
      n = rnd( [ 7, @player.intelligence >> 1 ].max )
      
      @dir = DIR[ rand( 8 ) ] if ( n == 1 || n == 2 )
      
    end
    
    def disappear? # ǡ
      @life < 0
    end

  end
  
  class SPELL
    
    # ʸ38
    
    CODE = [ 
      "pro",
      "mle",
      "dex",
      "sle",
      "chm",
      "ssp",
      "web",
      "str",
      "enl",
      "hel",
      "cbl",
      "cre",
      "pha",
      "inv",
      "bal",
      "cld",
      "ply",
      "can",
      "has",
      "ckl",
      "vpr",
      "dry",
      "lit",
      "drl",
      "glo",
      "flo",
      "fgr",
      "sca",
      "hld",
      "stp",
      "tel",
      "mfi", # /* 31 */
      "sph",
      "gen",
      "sum",
      "wtw",
      "alt",
      "per",
      "pul" # ¤ꡣ
    ]
    
    attr_reader :id
    
    def initialize( code )
      @code = code
    end
    
    def id ; CODE.index( @code ) ; end
    
    def SPELL.id2code( id ) ; CODE[ id ] ; end
    
    def invalid? ; !id ; end # ̵ˡ
    
    def protection?             ; id ==  0 ; end
    def magic_missile?          ; id ==  1 ; end
    def dexterity?              ; id ==  2 ; end
    def sleep?                  ; id ==  3 ; end
    def charm_monster?          ; id ==  4 ; end
    def sonic_spear?            ; id ==  5 ; end
    def web?                    ; id ==  6 ; end
    def strength?               ; id ==  7 ; end
    def enlightenment?          ; id ==  8 ; end
    def healing?                ; id ==  9 ; end
    def cure_blindness?         ; id == 10 ; end
    def create_monster?         ; id == 11 ; end
    def phantasmal_forces?      ; id == 12 ; end
    def invisibility?           ; id == 13 ; end
    def fireball?               ; id == 14 ; end
    def cold?                   ; id == 15 ; end
    def polymorph?              ; id == 16 ; end
    def cancellation?           ; id == 17 ; end
    def haste_self?             ; id == 18 ; end
    def cloud_kill?             ; id == 19 ; end
    def vaporize_rock?          ; id == 20 ; end
    def dehydration?            ; id == 21 ; end
    def lightning?              ; id == 22 ; end
    def drain_life?             ; id == 23 ; end
    def invulnerability?        ; id == 24 ; end
    def flood?                  ; id == 25 ; end
    def finger_of_death?        ; id == 26 ; end
    def scare_monster?          ; id == 27 ; end
    def hold_monster?           ; id == 28 ; end
    def time_stop?              ; id == 29 ; end
    def teleport_away?          ; id == 30 ; end
    def magic_fire?             ; id == 31 ; end
    def sphere_of_annihilation? ; id == 32 ; end
    def genocide?               ; id == 33 ; end
    def summon_demon?           ; id == 34 ; end
    def walk_through_walls?     ; id == 35 ; end
    def alter_reality?          ; id == 36 ; end
    def permanence?             ; id == 37 ; end
    
    def pulverization?          ; id == 38  ; end

    def SPELL.pulverization ; self.new( "pul" ) ; end
    
  end

  
  def get_spell( client, enter_spell, aborted, header, list, press_enter )
    client.get_spell( enter_spell, aborted, header, list, press_enter ) 
  end
  
  def cast_spell( client, point )
  
    player = client.player
    mesg   = player.mesg

    if ( player.spells < 1 ) # ڤ졣
      message( client, mesg[ 740 ] )
      return true # ˥ȡ
    end

    if !( code = get_spell( client, mesg[ 741 ], mesg[ 742 ], mesg[ 743 ],
			    player.spell_list, mesg[ 152 .. 154 ] ) )
      return true # ʸ󥻥⡢˥ȡ
    end

    player.spell_cast # Ϥ

    spell = SPELL.new( code )
    
    if spell.invalid? || !player.spell_know?( spell )
      message( client, mesg[ 744 ] )
    elsif player.timestop?
      message( client, mesg[ 745 ] ) # timestopϡˡ̵
    elsif player.spell_fail?        # ޤ˥ߥޤ
      message( client, mesg[ 746 ] )
    elsif player.inexperienced_for_spell?( spell ) 
      # и­ȤΤ졣
      message( client, mesg[ 747 ] )
    else
      spell_damage( client, spell, point )
    end
      
    true # ꡣ
    
  end

  def spell_damage( client, spell, point )

 
    if spell.protection? # ٥1ˡ
      spell_protection( client )
    elsif spell.magic_missile?
      spell_magic_missile( client, spell, point )
    elsif spell.dexterity?
      spell_dexterity( client )
    elsif spell.sleep?
      spell_sleep( client, spell, point )
    elsif spell.charm_monster?
      spell_charm_monster( client )
    elsif spell.sonic_spear?
      spell_sonic_spear( client, spell, point )
    elsif spell.web? # 衢٥2ˡ
      spell_web( client, spell, point )
    elsif spell.strength?
      spell_strength( client )
    elsif spell.enlightenment?
      spell_enlightenment( client, point )
    elsif spell.healing?
      spell_healing( client )
    elsif spell.cure_blindness?
      spell_cure_blindness( client, point )
    elsif spell.create_monster?
      spell_create_monster( client, point )
    elsif spell.phantasmal_forces?
      spell_phantasmal_forces( client, spell, point )
    elsif spell.invisibility?
      spell_invisibility( client )
    elsif spell.fireball? # 衢٥3ˡ
      spell_fireball( client, spell, point )
    elsif spell.cold?
      spell_cold( client, spell, point )
    elsif spell.polymorph?
      spell_polymorph( client, spell, point )
    elsif spell.cancellation?
      spell_cancellation( client )
    elsif spell.haste_self?
      haste_self( client )
    elsif spell.cloud_kill?
      spell_cloud_kill( client, spell, point )
    elsif spell. vaporize_rock?
      spell_vaporize_rock( client, spell, point )
    elsif spell.dehydration?
      spell_dehydration( client, spell, point ) # 衢٥4ˡ
    elsif spell.lightning?
      spell_lightning( client, spell, point )
    elsif spell.drain_life?
      spell_drain_life( client, spell, point )
    elsif spell.invulnerability?
      spell_invulnerability( client )
    elsif spell.flood?
      spell_flood( client, spell, point )
    elsif spell.finger_of_death?
      spell_finger_of_death( client, spell, point )
    elsif spell.scare_monster? # ٥5ˡ
      spell_scare_monster( client )
    elsif spell.hold_monster?
      spell_hold_monster( client )
    elsif spell.time_stop?
      spell_time_stop( client )
    elsif spell.teleport_away?
      spell_teleport_away( client, spell, point )
    elsif spell.magic_fire?
      spell_magic_fire( client, spell, point )
    elsif spell.sphere_of_annihilation?
      spell_sphere_of_annihilation( client, spell, point ) # ٥6ˡ
    elsif spell.genocide?
      spell_genocide( client, spell, point )
    elsif spell.summon_demon?
      spell_summon_demon( client, spell, point )
    elsif spell.walk_through_walls?
      spell_walk_throught_walls( client )
    elsif spell.alter_reality?
      spell_alter_reality( client, spell, point )
    elsif spell.permanence?
      spell_permanence( client, spell )
    end
    
  end
  
  def spell_protection( client )
    client.player.get_protectiontime
  end

  def spell_magic_missile( client, spell, point )

    player = client.player
    mesg   = player.mesg
    
    go_direct( client, point, spell, player.spell_might( spell ),
	      ( player.level >= 2 )? mesg[ 750 .. 758 ] : mesg[ 760 .. 768 ] )

  end

  def spell_dexterity( client )
    client.player.get_dexcount
  end

  def spell_sleep( client, spell, point )

    player = client.player
    direct( client, spell, point, player.mesg[ 769 ], player.sleep_time )

  end
  
  # mightϼʸζ
  # ºݤ˥᡼ͿȤˤϡ򤫤ޤ
  # sleep_time̲餻Ƥ֤Ǥsleepwebѡ
  
  def direct( client, spell, point, string = nil, sleep_time = 0 )

    player = client.player
    mesg   = player.mesg
    
    return if isconfuse?( client )
    
    target_point = next_point( point, get_direction( client ) )
    might = player.spell_might( spell, sleep_time )
    
    # ˡä˶ȿͤƼʬ...ϼ
    # Larn 12.0Υˡ"fool" ̾ꡣ

    if ( obj = @cavelevel.point2object( point ) ) && ( obj.mirror? )
    
      if spell.sleep? # ̲롣
	message( client, mesg[ 770 ] )
	player.get_sleep( sleep_time + 2 )
      elsif spell.web?
	message( client, mesg[ 771 ] )
	player.get_sleep( sleep_time + 0 )
      else
	message( client, string, mesg[ 772 ] ) if string
	death_own_magic( client, might )
      end

    end

    if !( monster = @cavelevel.point2monster( target_point ) )
      message( client, mesg[ 773 ] )
    elsif nospell?( client, monster, spell )

    else
      message( client, string, player.monstername( monster ), sleep_time ) if string
      monsterdamaged( client, monster, target_point,
		     player.spell_damage( monster, might ) )
      
    end
    
  end
  
  def spell_charm_monster( client )
    client.player.get_charmcount
  end

  def spell_sonic_spear( client, spell, point )

    player = client.player
    
    go_direct( client, point, spell, player.spell_might( spell ),
	      player.mesg[ 774 .. 782 ] )
  end

  def spell_web( client, spell, point )

    player = client.player
    direct( client, spell, point, player.mesg[ 783 ], player.web_time )
    
  end

  def spell_strength( client )
    client.player.get_strcount
  end

  def spell_enlightenment( client, point )
    show_area( client, point, 5, 15 )
  end

  def spell_healing( client )
    client.player.spell_healing 
  end

  def spell_cure_blindness( client, point )
    client.player.lose_blindcount
  end

  def spell_create_monster( client, point )
    put_monster_near( client, Monster.create( @level + 1, 8 ), point )
  end

  def spell_phantasmal_forces( client, spell, point )

    player = client.player
    mesg   = player.mesg
    
    # ˡꡣphantasmal_forcesΨϡʤᡣ
    if player.phantasmal_forces_fail?
      message( client, mesg[ 2061 ] )
    else
      direct( client, spell, point, mesg[ 2060 ] )
    end
    
  end
  
  def spell_invisibility( client )
    client.player.add_invisibility
  end

  
  def spell_fireball( client, spell, point )

    player = client.player
    
    go_direct( client, point, spell, player.spell_might( spell ),
	      player.mesg[ 785 .. 793 ] )

  end

  def spell_cold( client, spell, point )

    player = client.player

    go_direct( client, point, spell, player.spell_might( spell ),
	      player.mesg[ 794 .. 802 ] )

    
  end

  # 󥹥̤Υ󥹥ˡ
  
  def spell_polymorph( client, spell, point )

    return if isconfuse?( client )

    target_point = next_point( point, get_direction( client ) )

    if !( monster = @cavelevel.point2monster( target_point ) )
      message( client, client.player.mesg[ 805 ] )
    elsif nospell?( client, monster, spell )

    else
      monster.polymorph
      update_point( client, target_point )
    end

  end

  def spell_cancellation( client ) 
    client.player.get_cancellation
  end

  def haste_self( client )
    client.player.get_hasteself
  end

  def spell_cloud_kill( client, spell, point )
    omnidirect( client, spell, point, client.player.mesg[ 806 ] )
  end

  def omnidirect( client, spell, point, format )
    
    player = client.player

    unless player.blindcount?
      client_magic_attack( client, spell, point )
      showcell( client, point )
    end
      
    might = player.spell_might( spell )

    # ܤ󥹥Фơˡ⡣
    @cavelevel.monsters_near_with_point( point ).each do | m_point, monster |

      next if nospell?( client, monster, spell ) # ˡ̵

      message( client, format, player.monstername( monster ) )
      
      monsterdamaged( client, monster, m_point,
		     player.spell_damage( monster, might ) )
      
    end

  end

  # pointܤƤüϷ᤭Ф

  # оݤϡ
  # ɡĦ̺¡ŤΤ( Larn 12.0  )
  
  # 󥹥xorn˥᡼Ϳ롣
  
  def spell_vaporize_rock( client, spell, point )

    player = client.player
    might  = player.spell_might( spell )
    
    # ɿ᤭Ф
    @cavelevel.wall_crumbles_near( point )

    # Ħ̺¡š
    @cavelevel.objects_near_with_point( point ).each do | o_point, object |
    
      if object.statue?
	crush_statue( client, object, o_point, might )
      elsif object.throne?
	throne_attack( client, object, o_point )
      elsif object.altar?
	altar_attack( client, object, o_point )
      end

    end

    client_magic_attack( client, spell, point )
    showcell( client, point )
    
    # XORN˥᡼
    @cavelevel.monsters_near_with_point( point ).each do | m_point, monster |
      monsterdamaged( client, monster, m_point, might ) if monster.xorn?
    end
    
  end

  def altar_attack( client, object, point )

    demonprince = Monster.demonprince

    return if put_monster( client, demonprince, point )
    put_monster_near( client, demonprince, point )

  end

  def spell_dehydration( client, spell, point )
    player = client.player
    direct( client, spell, point, player.mesg[ 808 ] )
  end
  
  def spell_lightning( client, spell, point )

    player = client.player
    
    go_direct( client, point, spell, player.spell_might( spell ),
	      player.mesg[ 808 .. 816 ] )
    
  end

  def spell_drain_life( client, spell, point )

    player = client.player
    
    might = player.spell_might( spell ) 
    direct( client, spell, point )
    client.player.losehp( might / 2 ) # drain_lifeǤϱӾԤϻʤʤ

  end

  def spell_invulnerability( client )
    client.player.get_globe
  end

  def spell_flood( client, spell, point )
    omnidirect( client, spell, point, client.player.mesg[ 820 ] )
  end

  def spell_finger_of_death( client, spell, point )

    player = client.player
    mesg   = player.mesg

    # ʤ궯ϤˡʤΤǡߥ¿Ǥ

    if player.self_finger_of_death? # 
      message( client, mesg[ 821 ] )
      death_wayward_finger( client )
    elsif player.finger_of_death_fail? # ԡ
      message( client, mesg[ 823 ] )
    else
      direct( client, spell, point, mesg[ 822 ] )
    end
    
  end

  def spell_scare_monster( client )
    client.player.get_scaremonst
  end
  
  def spell_hold_monster( client )
    client.player.get_spell_holdmonst
  end

  def spell_time_stop( client )
    client.player.get_timestop
  end

  # 󥹥᤭Ф
  # ᤭Ф줿󥹥ϡƱؤ̤ξ˰ưޤ
  
  def spell_teleport_away( client, spell, point )

    return if isconfuse?( client )

    target_point = next_point( point, get_direction( client ) )
    
    if !( monster = @cavelevel.point2monster( target_point ) )
      message( client, client.player.mesg[ 824 ] )
    elsif nospell?( client, monster, spell )
      # Фʤäǰ
    else

      # 󥸥⤫
      @cavelevel.monster_killed( monster, point )
      update_point( client, target_point )

      if ( to = @cavelevel.teleport_monster( monster ) )
	# ʾ˺֡
	update_point( client, to )
      end
      
    end

  end

  def spell_magic_fire( client, spell, point )
    omnidirect( client, spell, point, client.player.mesg[ 825 ] )
  end

  def spell_sphere_of_annihilation( client, spell, point )

    player = client.player
    mesg   = player.mesg

    if player.self_sphere_of_annihilation?
      message( client, mesg[ 826 ] )
      death_self_annihilated( client )
      return
    end

    player.lose_intelligence
    dir = get_direction( client )
    
    newsphere( client, next_point( point, dir ), dir, player.sphere_life )

  end

  def newsphere( client, point, dir, life )

    # 󥸥ˡsphere of annihilation֡
    move_sphere( client, SPHERE.new( client.player, dir, life ),
		nil, point )
    
  end

  def remove_sphere( client, sphere, point )

    @cavelevel.remove_sphere( sphere, point )
    update_point( client, point )
    
  end

  def move_all_spheres( client )

    mesg = client.player.mesg
    
    @cavelevel.all_spheres.each do | from, sphere |

      # ¾sphereȤξͤǡsphereǤƤʤɤ
      next unless @cavelevel.sphere_alive?( sphere )

      # 1󤴤ȤˡsphereΰϤޤޤ
      # ˤäƤѤޤ
      sphere.weaken
      sphere.change_dir

      if sphere.disappear? # ưǡ
	message( client, mesg[ 834 ] )
	remove_sphere( client, sphere, from  )
      else
	# ư
	move_sphere( client, sphere, from, next_point( from, sphere.dir ) ) 
      end

    end

  end
    
  def move_sphere( client, sphere, from, to )

    raise if from == to
    
    player = client.player
    mesg   = player.mesg

    if @cavelevel.point2sphere( to ) # sphereƱΤͤȯ
      message( client, mesg[ 830 ] )
      explode_sphere( client, sphere, to )
    end
        
    # ̤Ϥưޤ
    return if @cavelevel.out_of_range?( to )
    
    @cavelevel.move_sphere( sphere, from, to )
    update_point( client, from )
    update_point( client, to )

    # 󥹥ˤäƤϡsphere of annihilation٤Ǥäޤ 
   
    if !( monster = @cavelevel.point2monster( to ) )

    elsif monster.demon? && monster.dispel_sphere?
      message( client, mesg[ 827 ], player.real_monstername( monster ) )
      remove_sphere( client, sphere, to )
      return
    elsif monster.disenchantress?
      message( client, mesg[ 828 ], player.real_monstername( monster ) )
      explode_sphere( client, sphere, to )
      return
    end

    if player.cancellation?
      message( client, mesg[ 829 ] )
      explode_sphere( client, sphere, to )
      return
    end

    annihilated( client, to )
       
  end

  def annihilated( client, point )

    player = client.player
    mesg   = player.mesg
    
    @cavelevel.annihilated( point )
    update_point( client, point )
    
    unless @cavelevel.to_be_annihilated( point ).empty?
      mesg[ 831 .. 832 ].each { | str | message( client, str ) }
      death_self_annihilated( client )
    end
    
  end
  
    
  def explode_sphere( client, sphere, point )

    player = client.player

    player.lose_holdmonst
    player.lose_cancellation

    # sphereȯȤˤϡȾ2ʲΡץ쥤䡼󥹥
    # ƥࡢϷǡ̵ѡ

    @cavelevel.explode_sphere( point ) # ȯ
    
    unless @cavelevel.to_be_exploded( point ).empty?
      message( client, player.mesg[ 833 ] )
      death_sphere_of_annihilation( client )
    end

  end

  # ²ȤǤ饲४СRubyLarnꥸʥ롣
  # ̼ǤƤޤСŪ򼺤äƤޤΤǡ
  
  def home_exists_check( client )

    if ( @level == 0 ) && ( !@cavelevel.home_exists? )
      message( client, mesg[ 835 ] )
    end
    
  end

  def client_get_genocide( client, mesg )
    client.get_genocide( mesg )
  end

  def spell_genocide( client, spell, point )

    player = client.player
    mesg   = player.mesg

    if !( id = Monster.genocide( client_get_genocide( client, mesg[ 840 ] ) ) )
      message( client, mesg[ 842 ] ) # ̵
      return
    end

    message( client, mesg[ 841 ], player.real_monstername_id( id ) )
    @cavelevel.wipeout_monsters
    showcell( client, point )

    player.lose_intelligence
    player.forget_spell( spell )
    
  end
    
  def spell_summon_demon( client, spell, point )

    player = client.player
    mesg   = player.mesg

    if !( player.summon_demon_fail? )
      direct( client, spell, point, mesg[ 843 ] )
    elsif player.self_summon_demon?
      message( client, mesg[ 844 ] )
      death_revolting_demon( client, player.self_summon_demon_damage )
    else
      message( client, mesg[ 845 ] )
    end
    
  end

  def spell_walk_throught_walls( client )
    client.player.get_wtw
  end

  # ϷΤߤѤ롣
  # sphereƾõƥȥ󥹥ϤΤޤޡ
  # 볦(screen)ϤΤޤޤˤƤޤ
  
  def spell_alter_reality( client, spell, point )

    player = client.player
    
    @cavelevel.alter_reality
    showcell( client, point )

    # 󾧤餪ޤ
    player.lose_intelligence
    player.forget_spell( spell )
    
  end

  def spell_permanence( client, spell )

    player = client.player

    # ߤṳ̈Ĺֻ³ޤ
    player.adjust_time( -99999 )

    # 󾧤餪ޤ
    player.lose_intelligence
    player.forget_spell( spell )

  end
  
end
